#include "c_cpp_aliases/aliases.h"
#include "vector/vec.h"
#include "window/window.h"

void draw_line(window_t *wnd, vec2i_t p0, vec2i_t p1, colour_t colour) {
  if (p1.x < p0.x) {
    vec_swap(vec2i_t, p0, p1);
  }

  i32 x0 = p0.x;
  i32 y0 = p0.y;
  i32 x1 = p1.x;
  i32 y1 = p1.y;

  f32 a = ((f32)y1 - y0) / ((f32)x1 - x0);
  f32 y = y0;

  for (i32 x = x0; x <= x1; ++x) {
    set_pixel(wnd, x, (i32)y, colour);
    y += a;
  }
}
